module GlobalVariables

    implicit none

    !Nodes and related variables
    type GridNode
    !All variables must be initialized, else they take random value
    !If one is initialized here, the rest take the initial value 0

        integer(4) :: node_id, node_type  !Type 0 = sea, 1 = land, 2 = mountains, 3 = coast, 5 = grid border
        !variables for reproduction and dispersion
        real(8) :: FPalPop, FNeoPop, HGPop, FNeoPop2, FPalPop2, HGPop2
        integer(4) :: frontArrival  !When neoPop > threshold maxNeoPop
        
        !variables of the grid, location,sea travel
        integer(4), dimension(8) :: node_neighbors
        integer(4) :: x,y
        real(8) :: longitude, latitude
        integer(4), dimension(2) :: land_sea !# land/coast neighbors, sea neighbors
        integer(4) :: landNeighbors(4), seaNeighbors(4)  !land/coast Neighbors, seaNeighbors
        integer(4) :: numDestinations, destinations(0:25)  !# destination excluding the same node,
        !list of possible destinations (0 is itself)
        real(8) :: destinationWeight(0:25) !Weight of each possible destination. Index 0 is the persistence
    endtype 
    
    !Grid array
    integer(4) :: numNodes, i_node, x_numNodes, y_numNodes  !total number of nodes, node index
    type(GridNode),dimension(:),allocatable :: Nodes !Node array containing all the information on every Node on the grid
    integer(4),allocatable :: nodesGrid(:,:) !relates the notes with their position in the grid
    
    !lists of habitable an non habitable nodes
    integer(4),allocatable :: habitableNodes(:), nonHabitableNodes(:) 
    integer(4) :: numHabitableNodes, numNonHabitableNodes
        
    !Density    
    real(8) :: maxHGPop, maxFPop, threshold  !population at which we register arrival   

    !Dispersion
    real(8) :: persistence, maxSeaTravel, reprRateHG   !prob to remain, maximum sea travel distance
    integer(4),allocatable :: coastNodes(:)
    integer(4) :: numCoastNodes   
    
    !vertical cultural transmision
    real(8) :: interbreeding
    
end module GlobalVariables